"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    SearchResponse,
    avro_parse,
    load_schema,
)


class SearchVariantSetsResponse(SearchResponse):
    """
    This is the response from `POST /variantsets/search` expressed as
    JSON.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    _valueListName = "variantSets"

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import ga4gh as ga4gh_3_0_0

        return {
            "variantSets": ga4gh_3_0_0.VariantSet,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import ga4gh as ga4gh_3_0_0
        from protocols.protocol_5_0_0 import ga4gh as ga4gh_3_0_0

        return {
            "org.ga4gh.models.VariantSet": ga4gh_3_0_0.VariantSet,
            "org.ga4gh.methods.SearchVariantSetsResponse": ga4gh_3_0_0.SearchVariantSetsResponse,
        }

    __slots__ = [
        "nextPageToken",
        "variantSets",
    ]

    def __init__(
        self,
        nextPageToken=None,
        variantSets=list,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_0_0.SearchVariantSetsResponse model.

        :param nextPageToken:
            The continuation token, which is used to page through large result
            sets.   Provide this value in a subsequent request to
            return the next page of   results. This field will be
            empty if there aren't any additional results.
        :type nextPageToken: None | str
        :param variantSets:
            The list of matching variant sets.
        :type variantSets: list[VariantSet]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
